"""
name : listener
Version 01.0, 20220107
testversion fuer sockettest

_ask_tokens:
find answercommand lines
these lines can be used as answercommands to ask for the actual content
those with stack > 1 will ask for 1st stack only ("00" or "0000" added)

_trx_value:
actual values
as recreived
"""
# general
import os
import sys
import socket
import time
import threading


# Ethernet:
class ClientThread (threading.Thread):
    # ethernet client part, connecting to devices
    def __init__(self, client_socket, host, port, t_sendall, t_data):
        threading.Thread.__init__(self)
        self.client_socket = client_socket
        self.host = host
        self.port = port
        self.sendall = t_sendall
        self.data = t_data

    def run(self):
        try:
            self.client_socket.connect((self.host, self.port))
        except socket.error:
            # to be replaced by entry to log
            self.client_socket.close()
            exit()
        client_read = ClientThreadRead(self.client_socket, self.data)
        client_read.start()
        client_write = ClientThreadWrite(self.client_socket, self.sendall)
        client_write.start()
        while 1:
            pass


class ClientThreadRead (threading.Thread):
    # ethernet client part, connecting to devices
    def __init__(self, client_socket, t_data):
        threading.Thread.__init__(self)
        self.client_socket = client_socket
     #   self.client_socket.makefile = client_socket.makefile
        self.data = t_data

    def run(self):
        global data
        while 1:
            try:
                data = self.client_socket.recv(4096)
            except ConnectionAbortedError:
                print("read aborted")
                exit()


class ClientThreadWrite (threading.Thread):
    # ethernet client part, connecting to devices
    def __init__(self, client_socket, t_sendall):
        threading.Thread.__init__(self)
        self.client_socket = client_socket
        self.sendall = t_sendall

    def run(self):
        global sendall
        while True:
            if len(sendall) > 0:
                print("client send ", sendall)
                self.client_socket.sendall(sendall)
                sendall = ""


def start_ethernet_client(host, port, e_sendall, e_data):
    client_socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    client_thread = ClientThread(client_socket, host, port, e_sendall, e_data)
    client_thread.start()


# read actual configaration of device
# HOST = '192.168.2.100'
HOST = '127.0.0.1'
PORT = 23
sendall = ""
data = bytearray([])
start_ethernet_client(HOST, PORT, sendall, data)
ask_tokens_f = open("_ask_tokens")
ask_tokens_data = []
for lines in ask_tokens_f:
    ask_tokens_data.append(lines)
ask_tokens_f.close()
trx_value = "_trx_value"
if os.path.exists(trx_value):
    os.remove(trx_value)
trx_value_f = open(trx_value, "a")
i = 0
i_last = 65565
last_line = ""
s_time = 0
while i < len(ask_tokens_data):
    if i != i_last:
        lines = ask_tokens_data[i].rstrip()
        lines_split = lines.split(" ")
        send_string = hex(int(lines_split[0])).lstrip("0x").rstrip("L")
        if len(send_string) == 1 or len(send_string) == 3:
            send_string = "0" + send_string
        if len(lines_split) > 1:
            send_string += lines_split[1]
        sendall = bytes(send_string, 'utf-8')
        i_last = i
        s_time = time.time()
    if len(data) < 6 or data[-1] != 10:
        time.sleep(0.7)
        if time.time() - s_time > 5:
            print("timeout")
            i += 1
    else:
        data = data[:-1]
        if data != last_line:
            j = 0
            out = ""
            while j < len(data):
                h = hex(data[j]).lstrip("0x")
                if len(h) == 1:
                    h = "0"+ h
                out += h
                j += 1
            print("client recceived ", out)
            trx_value_f.write(out)
            trx_value_f.write(chr(10))
            last_line = data
            i += 1
trx_value_f.close()
