"""
name : v_fix_tables.py
last edited: 20211106
tables for all radios
"""


tone_frequency =   {0: [0x06,0x70],
                    1: [0x06, 0x93],
                    2: [0x07, 0x19],
                    3: [0x07, 0x44],
                    4: [0x07, 0x70],
                    5: [0x07, 0x97],
                    6: [0x08, 0x25],
                    7: [0x08, 0x54],
                    8: [0x08, 0x85],
                    9: [0x09, 0x15],
                    10: [0x09, 0x48],
                    11: [0x09, 0x74],
                    12: [0x10, 0x00],
                    13: [0x10, 0x35],
                    14: [0x10, 0x72],
                    15: [0x11, 0x09],
                    16: [0x11, 0x48],
                    17: [0x11, 0x88],
                    18: [0x12, 0x30],
                    19: [0x12, 0x73],
                    20: [0x13, 0x18],
                    21: [0x13, 0x65],
                    22: [0x14, 0x13],
                    23: [0x14, 0x62],
                    24: [0x15, 0x14],
                    25: [0x15, 0x67],
                    26: [0x15, 0x98],
                    27: [0x16, 0x22],
                    28: [0x16, 0x55],
                    29: [0x16, 0x79],
                    30: [0x17, 0x13],
                    31: [0x17, 0x38],
                    32: [0x17, 0x73],
                    33: [0x17, 0x99],
                    34: [0x18, 0x35],
                    35: [0x18, 0x62],
                    36: [0x18, 0x99],
                    37: [0x19, 0x28],
                    38: [0x19, 0x66],
                    39: [0x19, 0x95],
                    40: [0x20, 0x35],
                    41: [0x20, 0x65],
                    42: [0x21, 0x07],
                    43: [0x21, 0x81],
                    44: [0x22, 0x57],
                    45: [0x22, 0x91],
                    46: [0x23, 0x36],
                    47: [0x24, 0x18],
                    48: [0x25, 0x03],
                    49: [0x25, 0x41],
                    }


dtcs_frequency =   {0: [0x00,0x23],
                    1: [0x00, 0x25],
                    2: [0x00, 0x26],
                    3: [0x00, 0x31],
                    4: [0x00, 0x32],
                    5: [0x00, 0x36],
                    6: [0x00, 0x43],
                    7: [0x00, 0x47],
                    8: [0x00, 0x51],
                    9: [0x00, 0x53],
                    10: [0x00, 0x54],
                    11: [0x00, 0x65],
                    12: [0x00, 0x71],
                    13: [0x00, 0x72],
                    14: [0x00, 0x73],
                    15: [0x00, 0x74],
                    16: [0x01, 0x14],
                    17: [0x01, 0x15],
                    18: [0x01, 0x16],
                    19: [0x01, 0x22],
                    20: [0x01, 0x25],
                    21: [0x01, 0x31],
                    22: [0x01, 0x32],
                    23: [0x01, 0x34],
                    24: [0x01, 0x43],
                    25: [0x01, 0x45],
                    26: [0x01, 0x52],
                    27: [0x01, 0x55],
                    28: [0x01, 0x56],
                    29: [0x01, 0x62],
                    30: [0x01, 0x65],
                    31: [0x01, 0x72],
                    32: [0x01, 0x74],
                    33: [0x02, 0x05],
                    34: [0x02, 0x12],
                    35: [0x02, 0x23],
                    36: [0x02, 0x25],
                    37: [0x02, 0x26],
                    38: [0x02, 0x43],
                    39: [0x02, 0x44],
                    40: [0x02, 0x45],
                    41: [0x02, 0x46],
                    42: [0x02, 0x51],
                    43: [0x02, 0x52],
                    44: [0x02, 0x55],
                    45: [0x02, 0x61],
                    46: [0x02, 0x63],
                    47: [0x02, 0x65],
                    48: [0x02, 0x66],
                    49: [0x02, 0x71],
                    50: [0x02, 0x74],
                    51: [0x03, 0x06],
                    52: [0x03, 0x11],
                    53: [0x03, 0x15],
                    54: [0x03, 0x25],
                    55: [0x03, 0x31],
                    56: [0x03, 0x32],
                    57: [0x03, 0x43],
                    58: [0x03, 0x46],
                    59: [0x03, 0x51],
                    60: [0x03, 0x56],
                    61: [0x03, 0x64],
                    62: [0x03, 0x65],
                    63: [0x03, 0x71],
                    64: [0x04, 0x11],
                    65: [0x04, 0x12],
                    66: [0x04, 0x13],
                    67: [0x04, 0x23],
                    68: [0x04, 0x31],
                    69: [0x04, 0x32],
                    70: [0x04, 0x45],
                    71: [0x04, 0x46],
                    72: [0x04, 0x52],
                    73: [0x04, 0x54],
                    74: [0x04, 0x55],
                    75: [0x04, 0x62],
                    76: [0x04, 0x64],
                    77: [0x04, 0x65],
                    78: [0x04, 0x66],
                    79: [0x05, 0x03],
                    80: [0x05, 0x06],
                    81: [0x05, 0x16],
                    82: [0x05, 0x23],
                    83: [0x05, 0x25],
                    84: [0x05, 0x32],
                    85: [0x05, 0x46],
                    86: [0x05, 0x65],
                    87: [0x06, 0x06],
                    88: [0x06, 0x12],
                    89: [0x06, 0x24],
                    90: [0x06, 0x27],
                    91: [0x06, 0x31],
                    92: [0x06, 0x32],
                    93: [0x06, 0x54],
                    94: [0x06, 0x62],
                    95: [0x06, 0x64],
                    96: [0x07, 0x03],
                    97: [0x07, 0x12],
                    98: [0x07, 0x23],
                    99: [0x07, 0x31],
                    100: [0x07, 0x32],
                    101: [0x07, 0x34],
                    102: [0x07, 0x43],
                    103: [0x07, 0x54],
                    }

dtcs_pol =  {0: 0x00,
             1: 0x01,
             2: 0x10,
             3: 0x11,
             }
